#include "TestEnvTests.h"

#include <iostream>
#include <sstream>

TestEnvTests::TestEnvTests(const char * testName)
  : TestEnv(testName)
{
}

void
TestEnvTests::testReplicas(const size_t serviceNo, const size_t rwReplicas, const size_t roReplicas)
{
  std::string servicename01(getServiceName(serviceNo));
  std::cout << "[OVAL] start RW part for " << servicename01 << std::endl;

  std::vector<std::string> connstrings01 = sw.getAllReplicas( servicename01, coral::Update, rwReplicas );
  if(connstrings01.size() != rwReplicas){
    std::ostringstream s;
    s << "Servicename (" << servicename01 << ") contains (" << connstrings01.size() << ") replicas for RW, but (" << rwReplicas << ") expected";
    throw coral::TestEnvException( s.str() , "TestEnvTests::testReplicas()" );
  }
    
  std::vector<std::string>::iterator i01;
  for(i01 = connstrings01.begin(); i01 != connstrings01.end(); i01++ )
  {
    std::cout << "[OVAL] found RW connection string for servicename " << servicename01 << " : " << *i01 << std::endl;
  }

  std::string servicename02(getServiceName(serviceNo));
  std::cout << "[OVAL] start RO part for " << servicename01 << std::endl;
        
  std::vector<std::string> connstrings02 = sw.getAllReplicas( servicename02, coral::ReadOnly, roReplicas );
  if(connstrings02.size() != roReplicas){
    std::ostringstream s;
    s << "Servicename (" << servicename02 << ") contains (" << connstrings02.size() << ") replicas for RO, but (" << roReplicas << ") expected";
    throw coral::TestEnvException( s.str() , "TestEnvTests::testReplicas()" );
  }
    
  std::vector<std::string>::iterator i02;
  for(i02 = connstrings02.begin(); i02 != connstrings02.end(); i02++ )
  {
    std::cout << "[OVAL] found RO connection string for servicename " << servicename02 << " : " << *i02 << std::endl;
  }


}
